Index: ps/trunk/binaries/data/mods/public/gui/gamesetup/gamesetup.js
===================================================================
--- ps/trunk/binaries/data/mods/public/gui/gamesetup/gamesetup.js	(revision 18175)
+++ ps/trunk/binaries/data/mods/public/gui/gamesetup/gamesetup.js	(working copy)
@@ -66,7 +66,7 @@
 	{
 		"id": "default",
 		"name": translate("Default"),
-		"filter": mapKeywords => mapKeywords.every(keyword => ["naval", "demo", "hidden"].indexOf(keyword) == -1)
+		"filter": mapKeywords => mapKeywords.every(keyword => ["trigger", "naval", "demo", "hidden"].indexOf(keyword) == -1)
 	},
 	{
 		"id": "naval",
@@ -79,6 +79,11 @@
 		"filter": mapKeywords => mapKeywords.indexOf("demo") != -1
 	},
 	{
+		"id": "trigger",
+		"name": translate("Trigger Maps")
+		"filter": mapKeywords => mapKeywords.indexOf("trigger") != -1
+	},
+	{
 		"id": "all",
 		"name": translate("All Maps"),
 		"filter": mapKeywords => true
Index: ps/trunk/binaries/data/mods/public/maps/random/survivalofthefittest.json
===================================================================
--- ps/trunk/binaries/data/mods/public/maps/random/survivalofthefittest.json	(revision 18175)
+++ ps/trunk/binaries/data/mods/public/maps/random/survivalofthefittest.json	(working copy)
@@ -5,6 +5,7 @@
 		"Description" : "[color=\"red\"]IMPORTANT NOTE: AI PLAYERS DO NOT WORK WITH THIS MAP[/color]\n\nProtect your base against endless waves of enemies. Use your woman citizen to collect the treasures at the center of the map before others do, and try to build your base up. The last player remaining will be the winner!",
 		"BaseTerrain" : ["medit_sea_depths"],
 		"BaseHeight" : 30,
+		"Keywords": ["trigger"],
 		"Preview" : "survivalofthefittest.png",
 		"CircularMap" : true,
 		"TriggerScripts": [
Index: ps/trunk/binaries/data/mods/public/maps/scenarios/Introductory Tutorial.xml
===================================================================
--- ps/trunk/binaries/data/mods/public/maps/scenarios/Introductory Tutorial.xml	(revision 18175)
+++ ps/trunk/binaries/data/mods/public/maps/scenarios/Introductory Tutorial.xml	(working copy)
@@ -45,6 +45,7 @@
   "Description": "This is a basic tutorial to get you started playing 0 A.D.",
   "GameType": "conquest",
   "Keywords": [
+    "trigger",
     "demo"
   ],
   "LockTeams": false,
Index: ps/trunk/binaries/data/mods/public/maps/scenarios/starting_economy_walkthrough.xml
===================================================================
--- ps/trunk/binaries/data/mods/public/maps/scenarios/starting_economy_walkthrough.xml	(revision 18175)
+++ ps/trunk/binaries/data/mods/public/maps/scenarios/starting_economy_walkthrough.xml	(working copy)
@@ -53,6 +53,7 @@
   "Description": "This map will give a rough guide for starting the game effectively.  Early in the game the most important thing is to gather resources as fast as possible so you are able to build enough troops later.\u000a\u000aWarning: This is very fast at the start, be prepared to run through the initial bit several times.",
   "GameType": "conquest",
   "Keywords": [
+    "trigger",
     "demo"
   ],
   "LockTeams": false,
Index: ps/trunk/binaries/data/mods/public/maps/scenarios/Treasure Islands.xml
===================================================================
--- ps/trunk/binaries/data/mods/public/maps/scenarios/Treasure Islands.xml	(revision 18175)
+++ ps/trunk/binaries/data/mods/public/maps/scenarios/Treasure Islands.xml	(working copy)
@@ -48,6 +48,7 @@
   "Description": "Search treasures on small islands and on the water. Collect more treasures than your opponent to win.",
   "GameType": "conquest",
   "Keywords": [
+    "trigger",
     "naval"
   ],
   "LockTeams": false,
Index: ps/trunk/binaries/data/mods/public/maps/scenarios/Triggers_demo.xml
===================================================================
--- ps/trunk/binaries/data/mods/public/maps/scenarios/Triggers_demo.xml	(revision 18175)
+++ ps/trunk/binaries/data/mods/public/maps/scenarios/Triggers_demo.xml	(working copy)
@@ -48,6 +48,7 @@
   "Description": "Demo map listening to various triggers and printing warning messages about them",
   "GameType": "endless",
   "Keywords": [
+    "trigger",
     "demo"
   ],
   "LockTeams": false,
Index: ps/trunk/binaries/data/mods/public/maps/scenarios/Units_demo.xml
===================================================================
--- ps/trunk/binaries/data/mods/public/maps/scenarios/Units_demo.xml	(revision 18175)
+++ ps/trunk/binaries/data/mods/public/maps/scenarios/Units_demo.xml	(working copy)
@@ -93,7 +93,10 @@
 	{
 		"Name":"Units Demo",
 		"Description":"Every unit in the game.",
-		"Keywords": ["demo"],
+		"Keywords": [
+		  "trigger",
+		  "demo"
+		],
 		"PlayerData":
 		[
 			{
Index: ps/trunk/binaries/data/mods/public/maps/skirmishes/Gallic Fields (3).xml
===================================================================
--- ps/trunk/binaries/data/mods/public/maps/skirmishes/Gallic Fields (3).xml	(revision 18175)
+++ ps/trunk/binaries/data/mods/public/maps/skirmishes/Gallic Fields (3).xml	(working copy)
@@ -43,7 +43,9 @@
   "CircularMap": true,
   "Description": "Defend your Gallic outpost against attacks from your treacherous neighbors!\n\nEach player begins the match with a wooden palisade and some guard towers atop a low embankment.\n\nWatch out for Romans passing by!",
   "GameType": "conquest",
-  "Keywords": [],
+  "Keywords": [
+    "trigger"
+  ],
   "LockTeams": false,
   "Name": "Gallic Fields (3)",
   "PlayerData": [