Index: binaries/data/mods/public/simulation/ai/petra/headquarters.js
===================================================================
--- binaries/data/mods/public/simulation/ai/petra/headquarters.js	(révision 16877)
+++ binaries/data/mods/public/simulation/ai/petra/headquarters.js	(copie de travail)
@@ -1450,13 +1450,13 @@
 		}
 	}
 
-	if (this.Config.Military.numWoodenTowers && gameState.currentPhase() < 2 && this.canBuild(gameState, "other/palisades_rocks_fort"))
+	if (this.Config.Military.numWoodenTowers && gameState.currentPhase() < 2 && this.canBuild(gameState, "structures/{civ}_wooden_tower"))
 	{
 		let numTowers = gameState.getOwnEntitiesByClass("Tower", true).length;	// we count all towers, including wall towers
 		if (numTowers < this.Config.Military.numWoodenTowers && gameState.ai.elapsedTime > this.towerLapseTime + this.fortStartTime)
 		{
 			this.fortStartTime = gameState.ai.elapsedTime;
-			queues.defenseBuilding.addItem(new m.ConstructionPlan(gameState, "other/palisades_rocks_fort"));
+			queues.defenseBuilding.addItem(new m.ConstructionPlan(gameState, "structures/{civ}_wooden_tower"));
 		}
 		return;
 	}
Index: binaries/data/mods/public/simulation/data/technologies/attack_tower_watch.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/attack_tower_watch.json	(révision 16877)
+++ binaries/data/mods/public/simulation/data/technologies/attack_tower_watch.json	(copie de travail)
@@ -10,8 +10,8 @@
 	},
 	"description": "A night's watch increases vigilance.",
 	"cost": {"food": 500, "wood": 0, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_town"},
-	"requirementsTooltip": "Unlocked in Town Phase.",
+	"requirements": {"tech": "phase_village"},
+	"requirementsTooltip": "Unlocked in Village Phase.",
 	"icon": "helmet_corinthian_bronze.png",
 	"researchTime": 40,
 	"tooltip": "Post sentries to add one arrow to towers.",
Index: binaries/data/mods/public/simulation/templates/other/palisades_rocks_fort.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/other/palisades_rocks_fort.xml	(révision 16877)
+++ binaries/data/mods/public/simulation/templates/other/palisades_rocks_fort.xml	(copie de travail)
@@ -21,6 +21,9 @@
       <stone>0</stone>
     </Resources>
   </Cost>
+  <Capturable>
+    <CapturePoints>800</CapturePoints>
+  </Capturable>
   <Footprint>
     <Square width="9.5" depth="8.5"/>
     <Height>9.0</Height>
@@ -28,20 +31,29 @@
   <Health>
     <Max>250</Max>
   </Health>
+  <GarrisonHolder>
+    <Max>3</Max>
+  </GarrisonHolder>
   <Identity>
-    <Civ>gaia</Civ>
-    <SpecificName>Palisade Fort</SpecificName>
+    <SpecificName>Wooden Tower</SpecificName>
     <GenericName>Wooden Tower</GenericName>
-    <Classes datatype="tokens">Palisade</Classes>
     <History>A cheap, quick defensive structure constructed with sharpened tree trunks</History>
     <Icon>structures/palisade_fort.png</Icon>
-	<VisibleClasses datatype="tokens">Village -Town DefenseTower</VisibleClasses>
+    <Classes datatype="tokens">WoodenTower</Classes>
+    <VisibleClasses datatype="tokens">Village -Town</VisibleClasses>
     <RequiredTechnology>phase_village</RequiredTechnology>
   </Identity>
-  <Obstruction>
-    <Static width="9.0" depth="7.5"/>
-  </Obstruction>
+  <ProductionQueue>
+    <Technologies datatype="tokens">
+      -attack_tower_crenellations
+      -attack_tower_range
+      -attack_tower_defense
+    </Technologies>
+  </ProductionQueue>
   <TerritoryInfluence disable=""/>
+  <StatusBars>
+    <HeightOffset>18.0</HeightOffset>
+  </StatusBars>
   <VisualActor>
     <Actor>props/special/palisade_rocks_fort.xml</Actor>
   </VisualActor>
Index: binaries/data/mods/public/simulation/templates/structures/athen_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/athen_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/athen_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>athen</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/brit_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/brit_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/brit_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>brit</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/cart_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/cart_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/cart_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>cart</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/gaul_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/gaul_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/gaul_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>gaul</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/iber_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/iber_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/iber_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>iber</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/mace_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/mace_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/mace_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>mace</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/maur_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/maur_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/maur_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>maur</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/pers_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/pers_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/pers_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>pers</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/ptol_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/ptol_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/ptol_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>ptol</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/rome_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/rome_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/rome_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>rome</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/sele_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/sele_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/sele_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>sele</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/structures/spart_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/structures/spart_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/structures/spart_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_structure_defense_wooden_tower">
+  <Identity>
+    <Civ>spart</Civ>
+  </Identity>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/template_structure_defense_wooden_tower.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_structure_defense_wooden_tower.xml	(révision 0)
+++ binaries/data/mods/public/simulation/templates/template_structure_defense_wooden_tower.xml	(copie de travail)
@@ -0,0 +1,3 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="other/palisades_rocks_fort">
+</Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_infantry.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_infantry.xml	(révision 16877)
+++ binaries/data/mods/public/simulation/templates/template_unit_infantry.xml	(copie de travail)
@@ -28,7 +28,7 @@
       structures/{civ}_corral
       structures/{civ}_outpost
       other/wallset_palisade
-      other/palisades_rocks_fort
+      structures/{civ}_wooden_tower
       structures/{civ}_dock
       structures/{civ}_barracks
       structures/{civ}_blacksmith
Index: binaries/data/mods/public/simulation/templates/units/rome_infantry_swordsman_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/rome_infantry_swordsman_b.xml	(révision 16877)
+++ binaries/data/mods/public/simulation/templates/units/rome_infantry_swordsman_b.xml	(copie de travail)
@@ -2,8 +2,8 @@
 <Entity parent="template_unit_infantry_melee_swordsman">
   <Builder>
     <Entities datatype="tokens">
-	   -other/wallset_palisade
-     -other/palisades_rocks_fort
+     -other/wallset_palisade
+     -structures/{civ}_wooden_tower
       structures/rome_army_camp
       structures/rome_wallset_siege
       structures/{civ}_wonder
@@ -12,8 +12,8 @@
   <Identity>
     <Civ>rome</Civ>
     <Lang>latin</Lang>
-	<SelectionGroupName>units/rome_infantry_swordsman_b</SelectionGroupName>
-	<GenericName>Roman Swordsman</GenericName>
+    <SelectionGroupName>units/rome_infantry_swordsman_b</SelectionGroupName>
+    <GenericName>Roman Swordsman</GenericName>
     <SpecificName>Hastatus</SpecificName>
     <Icon>units/rome_infantry_swordsman.png</Icon>
     <History>The hastati were the first line of heavy infantry in the early Republican Roman army. They used pila and gladii as their main weapons, throwing the former into the enemy formation and then closing with the sword. For defense they used a large shield called a scutum and wore the best armor they could afford. Hastati were recruited from the young men of Rome, a small part of the 700,000 troops Rome could bring to bear against its opponents.</History>