Index: binaries/data/mods/public/gui/page_summary.xml
===================================================================
--- binaries/data/mods/public/gui/page_summary.xml	(revision 16382)
+++ binaries/data/mods/public/gui/page_summary.xml	(working copy)
@@ -4,14 +4,6 @@
     <include>common/modern/styles.xml</include>
     <include>common/modern/sprites.xml</include>
 
-    <include>common/setup.xml</include>
-    <include>common/sprite1.xml</include>
-    <include>common/styles.xml</include>
-    <include>common/common_sprites.xml</include>
-    <include>common/common_styles.xml</include>
-    <include>common/icon_sprites.xml</include>
-    <include>common/init.xml</include>
-
     <include>summary/summary.xml</include>
     <include>summary/sprites.xml</include>
     <include>common/global.xml</include>
Index: binaries/data/mods/public/gui/summary/sprites.xml
===================================================================
--- binaries/data/mods/public/gui/summary/sprites.xml	(revision 16382)
+++ binaries/data/mods/public/gui/summary/sprites.xml	(working copy)
@@ -1,36 +1,36 @@
 <?xml version="1.0" encoding="utf-8"?>
 
 <sprites>
-        <sprite name="TabSpacer">
-                <image backcolor="gold" size="0 0 100% 100%"/>
+	<sprite name="TabSpacer">
+		<image backcolor="gold" size="0 0 100% 100%"/>
 	</sprite>
 
-        <sprite name="ForegroundTab">
-                <image backcolor="255 255 255 40" size="0 0 100% 100%"/>
-                <image backcolor="gold" size="0 0 2 100%"/>
-                <image backcolor="gold" size="2 0 100%-2 2"/>
-                <image backcolor="gold" size="100%-2 0 100% 100%"/>
+	<sprite name="ForegroundTab">
+		<image backcolor="255 255 255 40" size="0 0 100% 100%"/>
+		<image backcolor="gold" size="0 0 2 100%"/>
+		<image backcolor="gold" size="2 0 100%-2 2"/>
+		<image backcolor="gold" size="100%-2 0 100% 100%"/>
 	</sprite>
 
-        <sprite name="BackgroundTab">
-                <image backcolor="50 35 0 120" size="0 0 100% 100%"/>
-                <image backcolor="gold" size="0 0 1 100%"/>
-                <image backcolor="gold" size="1 0 100%-1 1"/>
-                <image backcolor="gold" size="100%-1 0 100% 100%"/>
+	<sprite name="BackgroundTab">
+		<image backcolor="50 35 0 120" size="0 0 100% 100%"/>
+		<image backcolor="gold" size="0 0 1 100%"/>
+		<image backcolor="gold" size="1 0 100%-1 1"/>
+		<image backcolor="gold" size="100%-1 0 100% 100%"/>
 	</sprite>
 
 	<sprite name="ForegroundBody">
 		<image backcolor="255 255 255 40" size="0 0 100% 100%"/>
-                <image backcolor="gold" size="0 0 2 100%"/>
-                <image backcolor="gold" size="2 100%-2 100%-2 100%"/>
-                <image backcolor="gold" size="100%-2 0 100% 100%"/>
+		<image backcolor="gold" size="0 0 2 100%"/>
+		<image backcolor="gold" size="2 100%-2 100%-2 100%"/>
+		<image backcolor="gold" size="100%-2 0 100% 100%"/>
 	</sprite>
-	
+
 	<sprite name="ForegroundBox">
 		<image backcolor="255 255 255 40" size="0 0 100% 100%"/>
-                <image backcolor="gold" size="0 0 2 100%"/>
-                <image backcolor="gold" size="2 100%-2 100%-2 100%"/>
-                <image backcolor="gold" size="100%-2 0 100% 100%"/>
+		<image backcolor="gold" size="0 0 2 100%"/>
+		<image backcolor="gold" size="2 100%-2 100%-2 100%"/>
+		<image backcolor="gold" size="100%-2 0 100% 100%"/>
 		<image backcolor="gold" size="0 0 100% 100%"/>
 	</sprite>
 </sprites>
Index: binaries/data/mods/public/gui/summary/summary.xml
===================================================================
--- binaries/data/mods/public/gui/summary/summary.xml	(revision 16382)
+++ binaries/data/mods/public/gui/summary/summary.xml	(working copy)
@@ -13,19 +13,16 @@
 	<script file="gui/summary/layout.js"/>
 	<script file="gui/summary/summary.js"/>
 
-	<object type="image"
-		style="ModernWindow"
-		size="0 0 100% 100%"
-	>
+	<object type="image" style="ModernWindow">
 		<object style="TitleText" type="text" size="50%-128 4 50%+128 36">
 			<translatableAttribute id="caption">Summary</translatableAttribute>
 		</object>
 
-		<object type="image" sprite="ForegroundBody" size="20 24 100%-20 80">
+		<object size="20 26 100%-20 92">
 
 			<object name="summaryText"
 				type="text"
-				size="50 6 100%-50 100%-20"
+				size="50 16 100%-50 100%-16"
 				font="sans-bold-18"
 				textcolor="255 255 255"
 				text_align="left"
@@ -34,17 +31,17 @@
 
 			<object name="timeElapsed"
 				type="text"
-				size="100%-200 8 100%-10 100%-20"
-				font="sans-16"
+				size="50 16 100%-50 100%-16"
+				font="sans-bold-18"
 				textcolor="255 255 255"
-				text_align="center"
+				text_align="right"
 				text_valign="center"
 			/>
 
 			<object name="mapName"
 				type="text"
-				size="50 20 100%-50 100%-4"
-				font="sans-bold-16"
+				size="50 16 100%-50 100%-16"
+				font="sans-bold-18"
 				textcolor="255 255 255"
 				text_align="center"
 				text_valign="center"
@@ -97,7 +94,7 @@
 			</object>
 		</object>
 
-		<object name="generalPanel" type="image" sprite="ForegroundBody" size="20 120 100%-20 100%-58">
+		<object name="generalPanel" type="image" sprite="ForegroundBody" size="20 120 100%-20 100%-54">
 			<object size="0 0 100% 100%-50">
 				<object name="playerNameHeading" type="text" style="ModernLeftTabLabelText">
 					<translatableAttribute id="caption">Player name</translatableAttribute>
@@ -153,10 +150,10 @@
 			</object>
 		</object>
 
-		<object type="button" style="StoneButton" size="100%-164 100%-52 100%-24 100%-24">
+		<object type="button" style="ModernButtonRed" size="100%-160 100%-48 100%-20 100%-20">
 			<translatableAttribute id="caption">Continue</translatableAttribute>
 			<action on="Press"><![CDATA[
-				if(!Engine.HasXmppClient())
+				if (!Engine.HasXmppClient())
 				{
 					Engine.SwitchGuiPage("page_pregame.xml");
 				}