Index: data/mods/public/art/actors/flora/trees/poplar.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/poplar.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/poplar.xml	(working copy)
@@ -36,6 +36,6 @@
     </variant>
   </group>
   
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 
 </actor>
Index: data/mods/public/art/actors/flora/trees/fig.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/fig.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/fig.xml	(working copy)
@@ -21,5 +21,5 @@
     </variant>
   </group>
   
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 </actor>
Index: data/mods/public/art/actors/flora/trees/oak.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/oak.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/oak.xml	(working copy)
@@ -26,6 +26,6 @@
     </variant>
   </group>
   
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 
 </actor>
Index: data/mods/public/art/actors/flora/trees/orchard_tree.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/orchard_tree.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/orchard_tree.xml	(working copy)
@@ -51,6 +51,6 @@
     </variant>
   </group>
   
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 
 </actor>
Index: data/mods/public/art/actors/flora/trees/carob.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/carob.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/carob.xml	(working copy)
@@ -56,5 +56,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 </actor>
Index: data/mods/public/art/actors/flora/trees/lumbardypoplar.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/lumbardypoplar.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/lumbardypoplar.xml	(working copy)
@@ -24,6 +24,6 @@
     </variant>
   </group>
 
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
   
 </actor>
Index: data/mods/public/art/actors/flora/trees/tree_tropic.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/tree_tropic.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/tree_tropic.xml	(working copy)
@@ -32,5 +32,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 </actor>
Index: data/mods/public/art/actors/flora/trees/apple_bloom.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/apple_bloom.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/apple_bloom.xml	(working copy)
@@ -39,6 +39,6 @@
     </variant>
   </group>
 
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 
 </actor>
Index: data/mods/public/art/actors/flora/trees/baobab.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/baobab.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/baobab.xml	(working copy)
@@ -40,5 +40,5 @@
       <textures><texture file="gaia/trunk_baobab.dds" name="baseTex"/></textures>
     </variant>
   </group>
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 </actor>
Index: data/mods/public/art/actors/flora/trees/oak_large.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/oak_large.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/oak_large.xml	(working copy)
@@ -29,6 +29,6 @@
     </variant>
   </group>
 
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
   
 </actor>
Index: data/mods/public/art/actors/flora/trees/european_beech.xml
===================================================================
--- data/mods/public/art/actors/flora/trees/european_beech.xml	(revision 16382)
+++ data/mods/public/art/actors/flora/trees/european_beech.xml	(working copy)
@@ -23,5 +23,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans_wind.xml</material>
+  <material>basic_wind.xml</material>
 </actor>
Index: data/mods/public/art/materials/trans_wind.xml
===================================================================
--- data/mods/public/art/materials/trans_wind.xml	(revision 16382)
+++ data/mods/public/art/materials/trans_wind.xml	(working copy)
@@ -1,7 +0,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<material>
-    <shader effect="model"/>
-    <renderquery name="sim_time"/>
-    <define name="USE_WIND" value="1"/>
-    <uniform name="windData" value="1.0 1.0"/>
-</material>
Index: data/mods/public/art/materials/basic_wind.xml
===================================================================
--- data/mods/public/art/materials/basic_wind.xml	(revision 0)
+++ data/mods/public/art/materials/basic_wind.xml	(working copy)
@@ -0,0 +1,7 @@
+<?xml version="1.0" encoding="utf-8"?>
+<material>
+    <shader effect="model"/>
+    <renderquery name="sim_time"/>
+    <define name="USE_WIND" value="1"/>
+    <uniform name="windData" value="1.0 1.0"/>
+</material>

Property changes on: data/mods/public/art/materials/basic_wind.xml
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property